#if !defined(AFX_OPTIONSDLG_H__4E64A1F2_3590_4B00_9876_10BD2B76A594__INCLUDED_)
#define AFX_OPTIONSDLG_H__4E64A1F2_3590_4B00_9876_10BD2B76A594__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ImageFileFormatDlg.h : header file
//

#include <vector>
#include "ImageFileFormat.h"

/////////////////////////////////////////////////////////////////////////////
// ImageFileFormatDlgDragListBox
/** @class ImageFileFormatDlgDragListBox
    @brief Include/NotInclude list boxes

    This class used to derive from CDragListBox, with further implementationof Dropped().
    Significant bugs caused us to revert back to CListBox, but these bugs could be 
    fixed with more time.
*/
class ImageFileFormatDlgDragListBox : public CListBox
{
public:
  ImageFileFormatDlgDragListBox();

  ImageFileFormatDlgDragListBox(ImageFileFormat* iff, class ImageFileFormatDlg* odlg)
    : m_iff(*iff), m_odlg(odlg)
  {
    CDragListBox();
  }

  void Dropped (int nSrcIndex, CPoint pt);

private:
  ImageFileFormat& m_iff;  ///< points to image file format
  ImageFileFormatDlg* m_odlg;  ///< points to options dlg
};

/////////////////////////////////////////////////////////////////////////////
// ImageFileFormatDlg dialog
/** @class ImageFileFormatDlg
  @brief The options dialog box

  This class helps in setting the file format.
  */
class ImageFileFormatDlg : public CDialog
{
// Construction
public:
	ImageFileFormatDlg(ImageFileFormat* image_file_format, const CString image_dir, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(ImageFileFormatDlg)
	enum { IDD = IDD_OPTIONS_DIALOG };
	CEdit	m_eSample;
	CButton	m_bDate;
  CListBox m_lbNotIncluded;
	ImageFileFormatDlgDragListBox	m_lbIncluded;
	CStatic	m_sEx;
	CEdit	m_ePrefix;
	CEdit	m_eExt;
	CEdit	m_eDelim;
	CButton	m_bRemove;
	CButton	m_bAdd;
	CButton	m_bBartz;
	CButton	m_bManual;
	CEdit	m_eEx;
	CComboBox	m_cDelim;
	//}}AFX_DATA

  ImageFileFormat* m_iff;               ///< points to image file format
  std::vector<OrderElement> m_Order;  ///< vector of order elements
  CString m_image_dir;

  CString GetImageFileFormat();       ///< returns image file format as a string
  CString GetDateFormat();
  void SetFormat();                   ///< updates the image file format with the data from the dialog
  bool GetSampleFiles();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ImageFileFormatDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ImageFileFormatDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeOptionsListIncluded();
	afx_msg void OnOptionsBartz();
	afx_msg void OnOptionsAdd();
	afx_msg void OnKillfocusOptionsEditDelim();
	afx_msg void OnKillfocusOptionsEditExt();
	afx_msg void OnKillfocusOptionsEditPrefix();
	afx_msg void OnSelchangeOptionsListNotincluded();
	afx_msg void OnOptionsRemove();
	afx_msg void OnOptionsStaticIffBox();
	afx_msg void OnOptions();
	afx_msg void OnOptionsCancel();
	afx_msg void OnKillfocusOptionsListIncluded();
	afx_msg void OnKillfocusOptionsListNotincluded();
	afx_msg void OnOptionsMoveUp();
	afx_msg void OnOptionsMoveDown();
	afx_msg void OnOK();
	afx_msg void OnOptionsDateFormat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONSDLG_H__4E64A1F2_3590_4B00_9876_10BD2B76A594__INCLUDED_)
